Loading...
Searching...
No Matches
Sip_rack

## Data Structures

struct | sip_rack_s
| Structure for RAck header. More...

## Macros

#define | sip_rack(sip)
| Access a SIP RAck header structure sip_rack_t from sip_t.
#define | SIP_RACK_INIT()
| Initializer for structure sip_rack_t.
#define | SIPTAG_RACK(x)
| Tag list item for pointer to a RAck header structure sip_rack_t.
#define | SIPTAG_RACK_REF(x)
| Tag list item for reference to a RAck header pointer.
#define | SIPTAG_RACK_STR(s)
| Tag list item for string with RAck header value.
#define | SIPTAG_RACK_STR_REF(x)
| Tag list item for reference to a RAck header string.

## Typedefs

typedef struct sip_rack_s | sip_rack_t
| @

## Functions

issize_t | sip_rack_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP RAck header.
issize_t | sip_rack_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP RAck header.
sip_rack_t * | sip_rack_init (sip_rack_t x[1])
| Initialize a structure sip_rack_t.
int | sip_is_rack (sip_header_t const *header)
| Test if header object is instance of sip_rack_t.
sip_rack_t * | sip_rack_dup (su_home_t *home, sip_rack_t const *hdr))
| Duplicate a list of RAck header header structures sip_rack_t.
sip_rack_t * | sip_rack_copy (su_home_t *home, sip_rack_t const *hdr))
| Copy a list of RAck header header structures sip_rack_t.
sip_rack_t * | sip_rack_make (su_home_t *home, char const *s))
| Make a RAck header structure sip_rack_t.
sip_rack_t * | sip_rack_format (su_home_t *home, char const *fmt,...)))
| Make a RAck header from formatting result.

## Variables

msg_hclass_t | sip_rack_class []
| Header class for RAck header.
tag_typedef_t | siptag_rack
| Tag for RAck header object.
tag_typedef_t | siptag_rack_str
| Tag for string with RAck header value.

## Detailed Description

## Macro Definition Documentation

## SIP_RACK_INIT

#define SIP_RACK_INIT | ( |  | ) |

Initializer for structure sip_rack_t.

A static sip_rack_t structure for RAck header must be initialized with the SIP_RACK_INIT() macro. For instance,

sip_rack_t sip_rack = SIP_RACK_INIT;
sip_rack_t
struct sip_rack_s sip_rack_t
@
Definition sip.h:171
sip_rack
#define sip_rack(sip)
Access a SIP RAck header structure sip_rack_t from sip_t.
Definition sip_protos.h:3225
SIP_RACK_INIT
#define SIP_RACK_INIT()
Initializer for structure sip_rack_t.
Definition sip_protos.h:3242

## SIPTAG_RACK

#define SIPTAG_RACK | ( |  | x | ) |

Tag list item for pointer to a RAck header structure sip_rack_t.

The SIPTAG_RACK() macro is used to include a tag item with a pointer to a sip_rack_t structure in a tag list.

Parameters

  x | pointer to a sip_rack_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_RACK_REF().

## SIPTAG_RACK_STR

#define SIPTAG_RACK_STR | ( |  | s | ) |

Tag list item for string with RAck header value.

The SIPTAG_RACK_STR() macro is used to include a tag item with a string containing value of a sip_rack_t header in a tag list.

Parameters

  s | pointer to a string containing RAck header value, or NULL.

The string in SIPTAG_RACK_STR() can be converted to a sip_rack_t header structure by giving the string s has second argument to function sip_rack_make().

The corresponding tag taking reference parameter is SIPTAG_RACK_STR_REF().

## Typedef Documentation

## sip_rack_t

typedef struct sip_rack_s sip_rack_t

@

The RAck header indicates the sequence number of the provisional response which is being acknowledged. Its syntax is defined in RFC 3262 section 10 as follows:

RAck = "RAck" HCOLON response-num LWS CSeq-num LWS Method
response-num = 1*DIGIT
CSeq-num = 1*DIGIT
DIGIT
#define DIGIT
LWS
#define LWS

See also
  RFC 3262, nta_outgoing_prack(), nta_reliable_treply(), nta_reliable_mreply().

The parsed RAck header is stored in sip_rack_t structure.

The structure sip_rack_t contains representation of an RAck header.

The sip_rack_t is defined as follows:

typedef struct sip_rack_s
{
sip_common_t ra_common; // Common fragment info
sip_error_t *ra_next; // Dummy link to next
uint32_t ra_response; // Sequence number of response
uint32_t ra_cseq; // Sequence number of request
sip_method_t ra_method; // Original request method
char const *ra_method_name; // Original request method name
} sip_rack_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_method_t
sip_method_t
IDs for well-known SIP methods.
Definition sip.h:48
sip_rack_s
Structure for RAck header.
Definition sip.h:579
sip_rack_s::ra_response
uint32_t ra_response
Sequence number of response.
Definition sip.h:582
sip_rack_s::ra_cseq
uint32_t ra_cseq
Sequence number of request.
Definition sip.h:583
sip_rack_s::ra_common
sip_common_t ra_common
Common fragment info.
Definition sip.h:580
sip_rack_s::ra_method_name
char const * ra_method_name
Original request method name.
Definition sip.h:585
sip_rack_s::ra_method
sip_method_t ra_method
Original request method.
Definition sip.h:584
sip_rack_s::ra_next
sip_error_t * ra_next
Dummy link to next.
Definition sip.h:581
uint32_t
SU_U32_T uint32_t

## Function Documentation

## sip_is_rack()

int sip_is_rack | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_rack_t.

Check if the header class is an instance of RAck header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header rack
  0 | (false) otherwise

## sip_rack_copy()

sip_rack_t * sip_rack_copy | ( | su_home_t * | home,
|  | sip_rack_t const * | hdr )

inline

Copy a list of RAck header header structures sip_rack_t.

The function sip_rack_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  rack = sip_rack_copy(home, sip->sip_rack);
  sip_rack_copy
  sip_rack_t * sip_rack_copy(su_home_t *home, sip_rack_t const *hdr))
  Copy a list of RAck header header structures sip_rack_t.
  Definition sip_protos.h:3372

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_rack_dup()

sip_rack_t * sip_rack_dup | ( | su_home_t * | home,
|  | sip_rack_t const * | hdr )

inline

Duplicate a list of RAck header header structures sip_rack_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  rack = sip_rack_dup(home, sip->sip_rack);
  sip_rack_dup
  sip_rack_t * sip_rack_dup(su_home_t *home, sip_rack_t const *hdr))
  Duplicate a list of RAck header header structures sip_rack_t.
  Definition sip_protos.h:3329

Returns
  A pointer to the newly duplicated sip_rack_t header structure, or NULL upon an error.

## sip_rack_format()

sip_rack_t * sip_rack_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a RAck header from formatting result.

Make a new sip_rack_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_rack_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_rack_init()

sip_rack_t * sip_rack_init | ( | sip_rack_t | x[1] | ) |

inline

Initialize a structure sip_rack_t.

An sip_rack_t structure for RAck header can be initialized with the sip_rack_init() function/macro. For instance,

sip_rack_t sip_rack;
sip_rack_init(&sip_rack);
sip_rack_init
sip_rack_t * sip_rack_init(sip_rack_t x[1])
Initialize a structure sip_rack_t.
Definition sip_protos.h:3260

## sip_rack_make()

sip_rack_t * sip_rack_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a RAck header structure sip_rack_t.

The function sip_rack_make() makes a new sip_rack_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_rack_t header structure, or NULL upon an error.

## Variable Documentation

## sip_rack_class

msg_hclass_t sip_rack_class[]

extern

Header class for RAck header.

The header class sip_rack_class defines how a SIP RAck header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_rack_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.